<template>
  <div>
    <PageWrapper dense contentFullHeight contentClass="flex">
      <OrganizationIdTree @select="handleSelect" ref="organizationIdTreeRef" />
      <BasicTable
        style="flex: auto"
        @register="registerTable"
        :searchInfo="searchInfo"
        class="w-3/4 xl:w-4/5"
        :clickToRowSelect="false"
      >
        <template #toolbar>
          <Authority value="api:yt:alarm:profile:post">
            <a-button type="primary" @click="handleCreateOrEdit(null)"> 新增告警配置 </a-button>
          </Authority>
          <Authority value="api:yt:alarm:profile:delete">
            <Popconfirm
              title="您确定要批量删除数据"
              ok-text="确定"
              cancel-text="取消"
              @confirm="handleDeleteOrBatchDelete(null)"
            >
              <a-button type="primary" color="error" :disabled="hasBatchDelete">
                批量删除
              </a-button>
            </Popconfirm>
          </Authority>
        </template>
        <template #alarmContact="{ record }">
          <a-button type="link" class="ml-2" @click="showAlarmContact(record)">
            查看联系人
          </a-button>
        </template>
        <template #messageMode="{ record }">
          <a-button type="link" class="ml-2" @click="showMessageMode(record)">
            查看通知方式
          </a-button>
        </template>
        <template #status="{ record }">
          <Switch
            :checked="record.status === 1"
            :loading="record.pendingStatus"
            checkedChildren="启用"
            unCheckedChildren="禁用"
            @change="(checked:boolean)=>statusChange(checked,record)"
          />
        </template>
        <template #action="{ record }">
          <TableAction
            :actions="[
              {
                label: '编辑',
                auth: 'api:yt:alarm:profile:update',
                icon: 'clarity:note-edit-line',
                onClick: handleCreateOrEdit.bind(null, record),
                ifShow: () => {
                  return record.status === 0;
                },
              },
              {
                label: '删除',
                auth: 'api:yt:alarm:profile:delete',
                icon: 'ant-design:delete-outlined',
                color: 'error',
                ifShow: () => {
                  return record.status === 0;
                },
                popConfirm: {
                  title: '是否确认删除',
                  confirm: handleDeleteOrBatchDelete.bind(null, record),
                },
              },
            ]"
          />
        </template>
      </BasicTable>
    </PageWrapper>
    <ContactDrawer @register="registerDrawer" @success="handleSuccess" />
  </div>
</template>

<script lang="ts">
  import { defineComponent, reactive, h, nextTick } from 'vue';
  import { BasicTable, useTable, TableAction } from '/@/components/Table';
  import { PageWrapper } from '/@/components/Page';
  import { useDrawer } from '/@/components/Drawer';
  import ContactDrawer from './ContactDrawer.vue';
  import { useResetOrganizationTree, OrganizationIdTree } from '/@/views/common/organizationIdTree';
  import { deleteAlarmConfig, queryAlarmConfig } from '/@/api/alarm/config/alarmConfig';
  import { searchFormSchema, columns } from './config.data';
  import { Modal, Popconfirm } from 'ant-design-vue';
  import { JsonPreview } from '/@/components/CodeEditor';
  import { findDictItemByCode } from '/@/api/system/dict';
  import { alarmContactGetPage } from '/@/api/device/deviceConfigApi';
  import { useBatchDelete } from '/@/hooks/web/useBatchDelete';
  import { Switch } from 'ant-design-vue';
  import { putAlarmConfigStatus } from '/@/api/alarm/config/alarmConfig';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { Authority } from '/@/components/Authority';

  export default defineComponent({
    components: {
      PageWrapper,
      OrganizationIdTree,
      BasicTable,
      TableAction,
      ContactDrawer,
      Switch,
      Authority,
      Popconfirm,
    },
    setup() {
      const searchInfo = reactive<Recordable>({});
      const { organizationIdTreeRef, resetFn } = useResetOrganizationTree(searchInfo);
      // 刷新
      const handleSuccess = () => {
        reload();
      };

      // 表格hooks
      const [registerTable, { reload, setProps, setSelectedRowKeys }] = useTable({
        title: '告警配置列表',
        api: queryAlarmConfig,
        columns,
        showIndexColumn: false,
        formConfig: {
          labelWidth: 120,
          schemas: searchFormSchema,
          resetFunc: resetFn,
        },
        useSearchForm: true,
        showTableSetting: true,
        bordered: true,
        actionColumn: {
          width: 200,
          title: '操作',
          dataIndex: 'action',
          slots: { customRender: 'action' },
          fixed: 'right',
        },
      });
      const { hasBatchDelete, handleDeleteOrBatchDelete, selectionOptions, resetSelectedRowKeys } =
        useBatchDelete(deleteAlarmConfig, handleSuccess, setProps);
      selectionOptions.rowSelection.getCheckboxProps = (record: Recordable) => {
        // Demo:status为1的选择框禁用
        if (record.status === 1) {
          return { disabled: true };
        } else {
          return { disabled: false };
        }
      };
      nextTick(() => {
        setProps(selectionOptions);
      });
      // 弹框
      const [registerDrawer, { openDrawer }] = useDrawer();

      // 新增或编辑
      const handleCreateOrEdit = (record: Recordable | null) => {
        if (record) {
          openDrawer(true, {
            isUpdate: true,
            record,
          });
        } else {
          openDrawer(true, {
            isUpdate: false,
          });
        }
      };

      // 树形选择器
      const handleSelect = (organizationId: string) => {
        searchInfo.organizationId = organizationId;
        handleSuccess();
      };
      const showAlarmContact = async (record) => {
        const { items } = await alarmContactGetPage();
        const joinArray = record.alarmContactId.split(',');
        let findName = [];
        findName = items.map((m) => {
          return {
            username: m.username,
            id: m.id,
          };
        });
        let arr3 = findName.filter((obj: any) => joinArray.some((obj1) => obj1 == obj.id));
        let arr4 = arr3.map((m: any) => {
          return m.username;
        });
        Modal.info({
          title: '当前告警通知联系人',
          width: 600,
          content: h(JsonPreview, { data: JSON.parse(JSON.stringify(arr4)) }),
        });
      };
      const showMessageMode = async (record) => {
        const data1: any = await findDictItemByCode({ dictCode: 'message_type' });
        const joinArray = record.messageMode.split(',');
        let findName = [];
        findName = data1.map((m: any) => {
          return {
            itemValue: m.itemValue,
            itemText: m.itemText,
          };
        });
        let arr3 = findName.filter((obj: any) => joinArray.some((obj1) => obj1 == obj.itemValue));
        let arr4 = arr3.map((m: any) => {
          return m.itemText;
        });

        Modal.info({
          title: '当前告警联系方式',
          width: 600,
          content: h(JsonPreview, { data: JSON.parse(JSON.stringify(arr4)) }),
        });
      };
      const statusChange = async (checked, record) => {
        setProps({
          loading: true,
        });
        setSelectedRowKeys([]);
        resetSelectedRowKeys();
        const newStatus = checked ? 1 : 0;
        const { createMessage } = useMessage();
        try {
          await putAlarmConfigStatus(newStatus, record.id);
          if (newStatus) {
            createMessage.success(`启用成功`);
          } else {
            createMessage.success('禁用成功');
          }
        } finally {
          setProps({
            loading: false,
          });
          reload();
        }
      };
      return {
        searchInfo,
        hasBatchDelete,
        handleCreateOrEdit,
        handleDeleteOrBatchDelete,
        handleSelect,
        handleSuccess,
        registerTable,
        registerDrawer,
        organizationIdTreeRef,
        showAlarmContact,
        showMessageMode,
        statusChange,
      };
    },
  });
</script>
